"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var path_1 = __importDefault(require("path"));
var fs_1 = __importDefault(require("fs"));
var lodash_1 = require("lodash");
var unist_builder_1 = __importDefault(require("unist-builder"));
var unist_util_visit_1 = __importDefault(require("unist-util-visit"));
function importCode(_a) {
    var baseDir = _a.baseDir, replace = _a.replace;
    return function transformer(tree, file) {
        function visitor(node, index, parent) {
            var _a;
            var parts = ((_a = node.meta) === null || _a === void 0 ? void 0 : _a.split(' ').map(function (part) { return part.split('='); })) || [];
            // @ts-ignore
            var meta = lodash_1.reduce(parts, function (meta, _a) {
                var key = _a[0], value = _a[1];
                meta[key] = value || true;
                return meta;
            }, { lang: node.lang });
            if (meta.import) {
                meta.file = path_1.default.join('./', "" + (baseDir !== null && baseDir !== void 0 ? baseDir : ''), meta.import);
                meta.path = path_1.default.join(file.cwd, './', "" + (baseDir !== null && baseDir !== void 0 ? baseDir : ''), meta.import);
                node.value = fs_1.default.readFileSync(meta.path, 'utf-8').trim();
                if (replace) {
                    var div = unist_builder_1.default('div', replace(node, meta, { u: unist_builder_1.default }));
                    if (div) {
                        // @ts-ignore
                        parent.children.splice(index, 1, div);
                    }
                }
            }
        }
        // @ts-ignore
        unist_util_visit_1.default(tree, 'code', visitor);
    };
}
module.exports = importCode;
